//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

#include <cstdlib>
#include <iostream>

using namespace std;

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

//----------------------------------------------------------------------------

template<typename T>
class MyStack
{
public:
  
  MyStack() { maxnum = 100; curnum = 0; A = new T[maxnum]; }    // make an empty stack

  void push(T);              // put item on the stack
  T pop();                   // take item off

  bool empty() { return curnum == 0; }
  bool full() { return curnum == maxnum; }
  int size() { return curnum; }
  void error(string s) { cout << "Error: " << s << endl; exit(1); }

private:

  T *A;
  int maxnum;
  int curnum;

};

//----------------------------------------------------------------------------

// item is new top of stack

template<typename T>
void MyStack<T>::push(T theData)
{
  if (!full()) 
    A[curnum++] = theData;
  else
    error("Tried to push on full stack");
}

//----------------------------------------------------------------------------

// return item currently on top of stack

template<typename T>
T MyStack<T>::pop()
{
  if (!empty())
    return A[--curnum];
  else
    error("Tried to pop from empty stack");
}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

void char_test()
{
  char next;

  MyStack<char> s;

  cout << "Enter some text\n";
  cin.get(next);
  while (next != '\n') {
    s.push(next);
    cin.get(next);
  }

  cout << "Written backward that is:\n";

  while (!s.empty())
    cout << s.pop();
  cout << "\n";

}

//----------------------------------------------------------------------------

void string_test()
{
  string next;
  char c;

  MyStack<string> s;

  cout << "Enter a sentence or two\n";

  while (cin >> next) {

    s.push(next);

    // was that the last word on the line?

    c = cin.get();

    if (c == '\n')
      break;
    else
      cin.putback(c);

  }

  cout << "Written backward that is:\n";
  
  while (!s.empty())
    cout << s.pop() << " ";
  cout << "\n";

}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

int main(int argc, char** argv)
{
  //char_test();
  string_test();

  return 1;
}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
